const _ = require('lodash')
const client = require('./client')
const tests = require('./tests')
const Config = require('./src/config')
const fs = require('fs');
const config = JSON.parse(fs.readFileSync('../aws/bugs/config.json'));

const server = 'localhost'
const key = '6804954f-e56d-471f-bbb8-08e3c54d9321'
const port = 3000

let directory = process.argv[2]
let index = parseInt(process.argv[3])

if (!directory || !index) {
  directory = 'bugs';
  index = config.current;
}

const matching = (actual, expected) => {
  if (!_.isEqual(actual, expected)) {
    return false;
  }
  return true;
}

const config_bug = require(`../aws/${directory}/${index}/config`);
const bug = JSON.parse(fs.readFileSync(`../aws/${directory}/${index}/bug.json`));
expected_results = JSON.parse(bug.expected_results)
expected_generated = JSON.parse(bug.expected_generated)

client.process(new Config(config_bug), key, server, port)
  .then( (responses) => {
    if (!matching(responses.results, expected_results)) {
      console.log('JSON does not match');
      console.log('actual', JSON.stringify(responses.results))
      console.log('expected', JSON.stringify(expected_results))
      process.exit(-1)
    }
    if (!matching(responses.generated, expected_generated)) {
      console.log('Generated does not match');
      console.log('actual', JSON.stringify(responses.generated))
      console.log('expected', JSON.stringify(expected_generated))
      process.exit(-1)
    }
  })
  .catch( (error) => { 
    console.log(error)
  })
